/*
 * @(#)adserver.java	1.0 98/07/07
 * 
 * Copyright (c) 1998 Studio Associato I-Tech All Rights Reserved.
 * 
 * 
 * I-Tech MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. I-Tech SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.0
 * 
 */


import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

// to gain benefits of having a pool of connections used in mutex
// manner and never closed until the destroy() of the servlet

import com.studioitech.gulli.MJDBC.*;  

public class adserver extends HttpServlet

{
	
	// Statics
	final static String JDBC_DriverName = "postgresql.Driver";
	final static String url = "jdbc:postgresql:ad";
	final static String usr = "test";
	final static String pwd = "test";
	final static int connection = 2;


	//Globals
	dbArbiterConnections arbiter;       // arbiter to get available con

	public String getServletInfo(){

		return "AD_Server v1.0 Studio Associato I-Tech";
	}


    // Init method, loaded in single thread mode by HTTP server

	public void init(ServletConfig config)
		throws ServletException
	{
		super.init(config);

		try {

			// Load arbiter to get available connections
			arbiter = new dbArbiterConnections(JDBC_DriverName, url, 
											   usr, pwd, connection);
		} catch (Exception e1){

			E.debug("Problems initing arbiter " + e1.toString(), 0);
		}

		E.debug("Initing done", 0);
	}


    // doGet Method - method that runs when the servlet is hit via GET

    public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException

    {

		PrintWriter	out;
		res.setContentType("text/html");
		out = res.getWriter ();

		E.setOutput(out);    // set output channel
		E.flush();           // flush the acquired buffer, if any
		E.setAutoFlush(true);// now set autoflush

		// A connection in the pool

		dbConnection conInPool;

		// get what i have to serve I can specify a MIME TYPE
		// or a KEY1 [KEY2], [KEY3] I must specify a DIM

		E.debug("Getting a request", 1);
		String type = req.getParameter("type");
		String dim  = req.getParameter("dim");
		String key1 = req.getParameter("key1");
		String key2 = req.getParameter("key2");
		String key3 = req.getParameter("key3");

		E.debug("<html>", 0);
		E.debug("<head><title>AD Server (Studio I-Tech) DEBUG</title></head>", 0);
		E.debug("<body>", 0);
		E.debug("<h1>DEBUG MODE</h1>", 0);

		E.debug("type=" + type + " dim=" + dim + " key1=" + key1 + 
				" key2=" + key2 + " key3=" + key3, 3);

		// Control dimension

		try{

			conInPool = arbiter.getAnAvailableCon();

			SQLwork sw = new SQLwork(conInPool.st, out);
			sw.doWork(type, dim, key1, key2, key3);

			conInPool.freeConnection();
		
		} catch (Exception e){

			E.debug("Got Exception: " + e.toString(), 0);
		}
	}


	// here goes all de-initialization

	public void destroy()
	{
		try {
			arbiter.shutdown();

		} catch(SQLException sqle)
		{
		}
	}
}



